unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Buttons, Dialogs, StdCtrls,
  ExtCtrls, ComCtrls, IBConnection, Dos, Crt, LCLType, fgl;

type

  { TFormAppli }

  TFormAppli = class(TForm)
    ImgList1: TImageList;
    ImgDes123: TImage;
    InfoCoche: TLabel;
    BtnLancer: TButton;
    BtnRejouer: TButton;
    BtnQuitter: TButton;
    CaseCoche1: TCheckBox;
    CaseCoche2: TCheckBox;
    CaseCoche3: TCheckBox;
    ImgDe1: TImage;
    ImgDe2: TImage;
    ImgDe3: TImage;
    Nbredessais: TLabel;
    procedure Tentative(essais: word);
    procedure BtnLancerClick(Sender: TObject);
    procedure BtnRejouerClick(Sender: TObject);
    procedure BtnQuitterClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);

  private
    essais :  word;
    a, b, c, reply, boxstyle : integer;
    gagne : string;
    procedure Rejouer;
    function Combitest : boolean;
    procedure ShowTirages;
    procedure HideTirages;

  public

  end;

var
  FormAppli: TFormAppli;

implementation

{$R *.lfm}

{ TFormAppli }

function TFormAppli.Combitest: boolean; //Test des combinaisons gagnantes
begin
  result:=(a+b+c+3=7) AND (a<>b) AND (a<>c) AND (b<>c);
end;

procedure TFormAppli.ShowTirages;
begin
   ImgDes123.Visible:=False;
   //montrer les cases à cocher
   CaseCoche1.Show;
   CaseCoche2.Show;
   CaseCoche3.Show;
   //Cacher l'info des cases à cocher
   InfoCoche.Show;
end;

procedure TFormAppli.HideTirages;
begin
  ImgDes123.visible:=True;
  //Effacer les dés
  ImgDe1.Picture.Clear;
  ImgDe2.Picture.Clear;
  ImgDe3.Picture.Clear;
  //Décocher les cases à cocher
  CaseCoche1.Checked:= False;
  CaseCoche2.Checked:= False;
  CaseCoche3.Checked:= False;
  //Cacher les cases à cocher
  CaseCoche1.Hide;
  CaseCoche2.Hide;
  CaseCoche3.Hide;
  //Cacher l'info des cases à cocher
  InfoCoche.Hide;
  //Cacher le bouton Rejouer
  BtnRejouer.Hide;
end;

procedure TFormAppli.Tentative(essais: word); //Comptage des lancers de dés
begin
    case essais of
  0 : Nbredessais.Caption:= 'Premier essai'; //Info 1er essai
  1 : Nbredessais.Caption:= 'Deuxième essai'; //Info 2ème essai
  2 : Nbredessais.Caption:= 'Dernier essai'; //Info dernier essai
  3 : Nbredessais.Caption:= 'Terminé !'; //Info terminé
    end;
end;

procedure TFormAppli.Rejouer; //Procédure pour rejouer
begin
  //Montrer le bouton Lancer les dés
  BtnLancer.Show;
  //Remettre le compteur et l'affichage d'essais à zéro
  essais:=0;
  Nbredessais.Caption:= 'Premier essai';
  gagne:=''; //Réinitialisation combinaison
  HideTirages;
  //ShowTirages;
  //CaseCoche1.Checked:= False;
  //CaseCoche2.Checked:= False;
  //CaseCoche3.Checked:= False;
  //Montrer le bouton Lancer les dés
  BtnLancer.Show;
end;

procedure TFormAppli.BtnLancerClick(Sender: TObject); //Pour BtnLancer les dés
begin
  inc(essais);
  ShowTirages;
  //Compter le nbre d'essais et l'afficher
  Tentative(essais);
  if essais>=3 then
  begin
    //Montrer le bouton Rejouer
    BtnRejouer.Show;
    exit;
  end;
  //Lancer le dé 1 de manière pseudo aléatoire
  randomize;
  //Lancer et afficher le dé 1 en fonction du statut de sa case à cocher
   if CaseCoche1.Checked = false then
  begin
    a := Random(6); //Tirage de 0 à 5 pour faces du dé de 1 à 6
    imglist1.Getbitmap(a,imgde1.picture.bitmap);
  end;
  //Fonctionnement identique adapté au dé 2
  if CaseCoche2.Checked = false then
  begin
    b := Random(6);
    imglist1.Getbitmap(b,imgde2.picture.bitmap);
  end;
  //Fonctionnement identique adapté au dé 3
    if CaseCoche3.Checked = false then
  begin
    c := Random(6);
    imglist1.Getbitmap(c,imgde3.picture.bitmap);
  end;
  repaint;
    //Comparer la combinaison de dés affichés avec les combinaisons gagnantes
    if Combitest = True then //Afficher le message quand c'est gagné
    with application do
      begin
      boxstyle := MB_YESNO;
      reply := MessageBox ('Bravo ! Vous avez gagné. Voulez-vous rejouer ?', 'GAGNE !!!', boxstyle);
      if reply = IDYES then
        Rejouer
      else
        Close; //Fermer l'application
      end;
end;

procedure TFormAppli.BtnRejouerClick(Sender: TObject); //Rejouer
begin
  Rejouer;
end;

procedure TFormAppli.BtnQuitterClick(Sender: TObject); //Fermer l'application
begin
  Close;
end;

procedure TFormAppli.FormCreate(Sender: TObject);
begin
  //Afficher les dés au départ
//  ImgDes123.Picture.LoadFromFile('dés123.jpg');
  //Initialiser les essais
  Nbredessais.Caption:= 'Premier essai';
end;

procedure TFormAppli.FormClose(Sender: TObject; var CloseAction: TCloseAction); //Fermeture application
begin
  Application.Terminate;
end;
end.
